#pragma once
#include <Windows.h>
#include <map>
#include <queue>
#include <functional>
#include <iostream>
class CThreadPool;


class CThreadPool
{
public:
	CThreadPool(int thread_count);
	~CThreadPool();
	void Release();
	bool PushJob(std::function<void()> job);
	void AlertableJob();
private:
	static DWORD WINAPI WorkProcess(LPVOID lpParam);
	void ClearJob();
	UINT WorkingCheck();
private:
	std::vector<HANDLE> mThreads;
	std::vector<UINT> mThreadID;
	std::queue<std::function<void()>> mJobs;
	const UINT mThreadCount;
	bool mbStopAll;
	CRITICAL_SECTION mlock;
	CONDITION_VARIABLE mcondition_v;
	UINT mRequestCnt;
	UINT mActiveJobCnt;
};


